﻿Public Class frmGame

    Dim boardImage As New Bitmap(579, 578)
    Dim r As New Random

    Private WithEvents tmr As New Timer With {.Interval = 3000}

    Dim numberOfMoves As Integer
    Dim game As Game

    ''' <summary>
    ''' initiates new game
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub frmGame_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        game = New Game(r, ChipPictureBox1, btnSpin, btnNew, PictureBox1)
        btnNew.PerformClick()
    End Sub

    ''' <summary>
    ''' Draws board image on form.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub frmGame_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.DrawImage(boardImage, New Point(12, 12))
    End Sub

    ''' <summary>
    ''' Asks user to select question type.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub frmGame_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        Dim frm As New frmQuestionChoice
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            game.questionType = frm.questionType
        Else
            Application.Exit()
        End If
    End Sub

    ''' <summary>
    ''' Sets up new game
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        boardImage = DirectCast(My.Resources.board.Clone, Bitmap)
        Dim gr As Graphics = Graphics.FromImage(boardImage)
        Game.newGame(gr, Me.Font)

        Me.Invalidate()
        btnNew.Enabled = False
        btnSpin.Enabled = True
    End Sub

    ''' <summary>
    ''' Spins the number spinner and selects a random number of moves from 1 to 6.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnSpin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSpin.Click
        PictureBox1.Image = My.Resources.spinner
        numberOfMoves = r.Next(1, 7)
        tmr.Start()
        btnSpin.Enabled = False
    End Sub

    ''' <summary>
    ''' Stops the number spinner, and continues game play.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub tmr_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmr.Tick
        tmr.Stop()
        PictureBox1.Image = DirectCast(My.Resources.ResourceManager.GetObject("_" & numberOfMoves.ToString), Bitmap)
        game.moveChip(numberOfMoves, Me)
    End Sub

End Class
