﻿Public Class frmGrammar

    ''' <summary>
    ''' Used to stop questions being randomly repeated
    ''' </summary>
    ''' <remarks></remarks>
    Private _used As List(Of Integer)
    Public Property indicesUsed() As List(Of Integer)
        Get
            Return _used
        End Get
        Set(ByVal value As List(Of Integer))
            _used = value
        End Set
    End Property

    ''' <summary>
    ''' Constructor
    ''' </summary>
    ''' <param name="r"></param>
    ''' <param name="used"></param>
    ''' <remarks>Selects a random question and puts the multi-choice answers in labels</remarks>
    Public Sub New(ByVal r As Random, ByVal used As List(Of Integer))
        InitializeComponent()
        Dim lines() As String = My.Resources.quiz.Split(New String() {Environment.NewLine}, StringSplitOptions.RemoveEmptyEntries)
        If used.Count = lines.Length Then
            used.Clear()
        End If
        Dim i As Integer = r.Next(0, lines.Length)
        While used.Contains(i)
            i = r.Next(0, lines.Length)
        End While
        used.Add(i)
        indicesUsed = used

        Dim parts() As String = lines(i).Split(":"c)
        Dim s1 As String = parts(0).Substring(0, parts(0).IndexOf("{"))
        Dim s2 As String = parts(0).Substring(parts(0).IndexOf("}") + 1)
        Dim s3 As String = parts(0).Substring(parts(0).IndexOf("{") + 1, parts(0).IndexOf("}") - parts(0).IndexOf("{") - 1)
        Dim words() As String = s3.Split("|"c)

        Label1.Text = s1 & "_____" & s2
        Dim labels() As Label = {Label2, Label3, Label4, Label5}
        For x As Integer = 0 To 3
            If x <= words.GetUpperBound(0) Then
                labels(x).Text = words(x)
            Else
                labels(x).Text = ""
                labels(x).Visible = False
            End If
        Next

        Dim w As Integer = Label6.Width + Label7.Width
        For x As Integer = 0 To 3
            If labels(x).Text <> "" Then
                w += labels(x).Width + 6
            End If
        Next
        w -= 6

        Dim xp As Integer = (Me.ClientSize.Width - w) \ 2

        Label6.Left = xp
        labels(0).Left = Label6.Right
        For x As Integer = 1 To 3
            If labels(x).Text <> "" Then
                labels(x).Left = labels(x - 1).Right + 6
                Label7.Left = labels(x).Right
            End If
        Next


        correctAnswer = CInt(parts(1))
        'Stop
    End Sub

    Private correctAnswer As Integer
    Private selectedAnswer As Integer

    ''' <summary>
    ''' btnPass
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>Clicked when user declines question</remarks>
    Private Sub btnPass_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPass.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
    End Sub

    ''' <summary>
    ''' btnSolve
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>Form.DialogResult depends on whether the answer is correct</remarks>
    Private Sub btnSolve_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSolve.Click
        If selectedAnswer = correctAnswer Then
            Label8.Text = "✔"
            Label8.Refresh()
            Threading.Thread.Sleep(500)
            Me.DialogResult = Windows.Forms.DialogResult.Yes
        Else
            Label8.Text = "X"
            Label8.Refresh()
            Threading.Thread.Sleep(500)
            Me.DialogResult = Windows.Forms.DialogResult.No
        End If
    End Sub

    ''' <summary>
    ''' Labels_Click
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>Onclick the Label forecolor and fontsize changes.
    ''' This resets all of the other labels, so only one appears selected.
    ''' Adjust locations to centre multi-choice Labels in Form</remarks>
    Private Sub Labels_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label5.Click, Label4.Click, Label3.Click, Label2.Click
        Dim labels() As Label = {Label2, Label3, Label4, Label5}
        For x As Integer = 0 To 3
            labels(x).ForeColor = Color.Silver
            labels(x).Font = New Font(labels(x).Font.FontFamily, 10)
            labels(x).Top = 109
        Next
        Dim i As Integer = Array.IndexOf(labels, sender)
        selectedAnswer = i
        labels(i).ForeColor = Color.SteelBlue
        labels(i).Font = New Font(labels(i).Font.FontFamily, 14)
        labels(i).Top = 125 - labels(i).Height + 3

        Dim w As Integer = Label6.Width + Label7.Width
        For x As Integer = 0 To 3
            If labels(x).Text <> "" Then
                w += labels(x).Width + 6
            End If
        Next
        w -= 6

        Dim xp As Integer = (Me.ClientSize.Width - w) \ 2

        Label6.Left = xp
        labels(0).Left = Label6.Right
        For x As Integer = 1 To 3
            If labels(x).Text <> "" Then
                labels(x).Left = labels(x - 1).Right + 6
                Label7.Left = labels(x).Right
            End If
        Next

        btnSolve.Enabled = True
    End Sub
End Class