﻿Public Class frmMaths

    Private correctAnswer As Integer

    Dim x As Integer

    Dim dt As New DataTable
    Dim operands(,) As String = {{"+", "-"}, {"/", "*"}}

    ''' <summary>
    ''' Constructor
    ''' </summary>
    ''' <param name="r"></param>
    ''' <remarks>Sets up NumericUpDown1.TextChanged
    ''' Formulates a random equation string with a hidden value
    ''' </remarks>
    Public Sub New(ByVal r As Random)
        InitializeComponent()

        AddHandler DirectCast(NumericUpDown1.Controls(1), TextBox).TextChanged, AddressOf txtChanged

        Dim i1 As Integer = r.Next(2, 11)
        Dim i2 As Integer = r.Next(2, 11)
        Dim i3 As Integer = r.Next(2, 11)

        Do While i2 = i1
            i2 = r.Next(1, 11)
        Loop

        Do While i3 = i1 Or i3 = i2
            i3 = r.Next(1, 11)
        Loop

        Dim s1 As String = operands(0, r.Next(0, 2)) & " " & i1.ToString
        Dim s2 As String = operands(1, r.Next(0, 2)) & " " & i2.ToString
        Dim s3 As String = operands(0, r.Next(0, 2)) & " " & i3.ToString

        x = r.Next(1, 101)
        Dim s4 As String = String.Format("((({0} {1}) {2}) {3})", x, s1, s2, s3)
        Do While CDec(dt.Compute(s4, Nothing)) Mod 1 <> 0
            x = r.Next(1, 101)
            s4 = String.Format("((({0} {1}) {2}) {3})", x, s1, s2, s3)
        Loop

        Label1.Text = String.Format("x {0} {1} {2}", s1, s2, s3) & " = " & CInt(dt.Compute(s4, Nothing)).ToString

        correctAnswer = x
    End Sub

    ''' <summary>
    ''' Pass Button
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>Clicked if user declines the question</remarks>
    Private Sub btnPass_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPass.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
    End Sub

    ''' <summary>
    ''' Solve Button
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>Form.DialogResult depends on whether the answer is correct</remarks>
    Private Sub btnSolve_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSolve.Click
        If CInt(NumericUpDown1.Value) = correctAnswer Then
            Label8.Text = "✔"
            Label8.Refresh()
            Threading.Thread.Sleep(500)
            Me.DialogResult = Windows.Forms.DialogResult.Yes
        Else
            Label8.Text = "X"
            Label8.Refresh()
            Threading.Thread.Sleep(500)
            Me.DialogResult = Windows.Forms.DialogResult.No
        End If
    End Sub

    ''' <summary>
    ''' NumericUpDown1.ValueChanged
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>Enables/disable btnSolve depending if NumericUpDown1.Value > 0D</remarks>
    Private Sub NumericUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown1.ValueChanged
        btnSolve.Enabled = NumericUpDown1.Value > 0D
    End Sub

    ''' <summary>
    ''' NumericUpDown1.TextChanged
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>Enables/disable btnSolve depending if NumericUpDown1.Value > 0</remarks>
    Private Sub txtChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim tb As TextBox = DirectCast(sender, TextBox)
        btnSolve.Enabled = Val(tb.Text) > 0
    End Sub

    ''' <summary>
    ''' Details1.Resize
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>Resizes Form when the dropdown calculator is shown/hidden</remarks>
    Private Sub Details1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Details1.Resize
        Me.Height = 205 + Details1.Height
    End Sub

End Class